#!/usr/bin/python

#
# Copyright (C) 2008 by OpenMoko, Inc.
# Written by Marek Lindner <marek@openmoko.com>
# All Rights Reserved
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#

import os


def debug(msg):
	print msg

class sysinfo_item:
	def __init__(self, etk_obj, edje, canvas, edje_file, edje_group):
		self.canvas_obj = etk_obj.Canvas()
		self.edje_obj = edje(canvas, file=edje_file, group=edje_group)
		self.canvas_obj.object_add(self.edje_obj)
		self.edje_obj.calc_force()
		self.edje_obj.show()

class sysinfo:
	def __init__(self, etk_obj, name="System Info"):
		self.name = name

		## gui ##
		self.etk_obj = etk_obj
		self.vbox = self.etk_obj.VBox()
		self.alignment = self.etk_obj.Alignment()
		self.alignment.set(1.0, 1.0, 1.0, 1.0)
		self.alignment.add(self.vbox)
		self.scrolled_view = self.etk_obj.ScrolledView()
		self.scrolled_view.add_with_viewport(self.alignment)
		## hide scrollbars
		self.scrolled_view.policy_set(2, 2)
		## make it dragable
		self.scrolled_view.dragable_set(1)

		self.data_file = "/etc/om-version"
		self.item_list = []
		self.runnable = 1
		if not (os.path.isfile(self.data_file)):
			self.runnable = 0
		#debug("enter init device : " + self.name)

	def init_label(self):
		#debug('init_label')
		for index, item in enumerate(["Tag Name", "Version", "Branch", "Build Host", "Time Stamp"]):
			list_item = sysinfo_item(self.etk_obj, self.edje, self.canvas, self.edje_file, "sysinfo_item_big")
			self.vbox.append(list_item.canvas_obj, self.etk_obj.VBox.START, self.etk_obj.VBox.EXPAND_FILL, 0)
			list_item.edje_obj.part_text_set("item-label", item)
			self.item_list.append(list_item)

			list_item = sysinfo_item(self.etk_obj, self.edje, self.canvas, self.edje_file, "sysinfo_item_small")
			self.vbox.append(list_item.canvas_obj, self.etk_obj.VBox.START, self.etk_obj.VBox.EXPAND_FILL, 0)
			list_item.edje_obj.part_text_set("item-label", "")
			self.item_list.append(list_item)

		self.update_label()

	def after_animate_click(self, edje_obj, emission, source):
		#debug('onclick')
		self.get_om_version()
		self.edj_object.signal_emit("sysinfo-slide-in", "exposure")
		self.edj_object.part_text_set("settings-text", "Settings / System Information")

	def update_label(self):
		#debug('update_label')
		self.edje_obj.part_text_set("item-status", "")

	def get_om_version(self):
		#debug('get_om_version')
		if self.runnable:
			file = open(self.data_file)
			version_info = file.readlines()
			for index, line in enumerate(version_info):
				self.item_list[(index * 2 + 1)].edje_obj.part_text_set("item-label", line.partition(':')[2].strip())
				if (index == 4):
					break
			file.close()
